Public Enum DatabaseAuthenticationType
    WindowsAuthentication
    DatabaseAuthentication
End Enum

Public Enum DatabaseType
    SQLServer
    Configuration
End Enum

Public Class DatabaseServer
    Inherits DatabaseObject

    Public DatabaseType As DatabaseType
    Public ServerName As String
    Public AuthenticationType As DatabaseAuthenticationType
    Public Login As String
    Public Password As String
    Public RememberPassword As Boolean


    Public ReadOnly Property ConnectionString() As String
        Get
            ConnectionString = ""
            Select Case DatabaseType
                Case SQLtoASPX.DatabaseType.SQLServer
                    ConnectionString = ConnectionString & "Server=" & ServerName
                    Select Case AuthenticationType
                        Case DatabaseAuthenticationType.WindowsAuthentication
                            ConnectionString = ConnectionString & ";Integrated Security=True;"
                        Case DatabaseAuthenticationType.DatabaseAuthentication
                            'uid=AmbBilling;pwd=Bill1ng!;
                            ConnectionString = ConnectionString & ";uid=" & Login & ";pwd=" & Password & ";"
                    End Select
            End Select
        End Get
    End Property

End Class
