﻿Imports System.Windows.Forms

Public Class frmDateFormat


    Private mValue As String
    Public Property Value() As String
        Get
            Return mValue
        End Get
        Set(ByVal value As String)
            mValue = value
        End Set
    End Property


    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        mValue = txt.Text
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub frmDateFormat_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'mValue = ""
        Dim ExampleDT As DateTime = DateTime.Parse("2/9/2010 1:9:7 PM")

        Dim dt As DataTable = GetDataTable()
        Dim dr As DataRow = dt.NewRow
        dr("format") = ""
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "M/d/yyyy h:m:s tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "M/d/yyyy h:m:ss tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)


        dr = dt.NewRow
        dr("format") = "M/d/yyyy h:mm:ss tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)


        dr = dt.NewRow
        dr("format") = "M/d/yyyy hh:mm:ss tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)



        dr = dt.NewRow
        dr("format") = "M/dd/yyyy hh:mm:ss tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)


        dr = dt.NewRow
        dr("format") = "MM/dd/yyyy hh:mm:ss tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "d"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "M/d/yyyy"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "D"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "dddd, MMM dd, yyyy"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "dddd, MMMM dd, yyyy"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "g"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "M/d/yyyy h:mm tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)


        dr = dt.NewRow
        dr("format") = "G"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)
        dr = dt.NewRow
        dr("format") = "M/d/yyyy h:mm:ss tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)


        dr = dt.NewRow
        dr("format") = "f"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "dddd, MMMM dd, yyyy h:mm tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)
        dr = dt.NewRow
        dr("format") = "F"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "dddd, MMMM dd, yyyy h:mm:ss tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "M"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "MMMM dd"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "R"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "ddd, dd MMM yyyy HH:mm:ss G\MT"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "s"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "yyyy-MM-ddTHH:mm:ss"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "t"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)


        dr = dt.NewRow
        dr("format") = "h:mm tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)


        dr = dt.NewRow
        dr("format") = "T"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "h:mm:ss tt"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)
        dr = dt.NewRow
        dr("format") = "u"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)
        dr = dt.NewRow
        dr("format") = "yyyy-MM-dd HH:mm:ssZ"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)
        dr = dt.NewRow
        dr("format") = "U"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        dr = dt.NewRow
        dr("format") = "Y"
        dr("output") = ExampleDT.ToString(dr("format"))
        dt.Rows.Add(dr)

        grd.DataSource = dt

        Timer1_Tick(Nothing, Nothing)

        If Len(mValue) > 0 Then
            For RowIndex As Long = 0 To grd.Rows.Count - 1
                If grd.Rows(RowIndex).Cells(0).Value = mValue Then
                    grd.Rows(RowIndex).Selected = True
                    grd.CurrentCell = grd.Rows(RowIndex).Cells(0)


                    txt.Text = grd.Rows(RowIndex).Cells(0).Value
                End If
            Next
        End If

    End Sub

    Private Function GetDataTable() As DataTable
        Dim dt As New DataTable
        Dim DataColumn As New DataColumn
        DataColumn.ColumnName = "Format"
        DataColumn.DataType = GetType(String)
        dt.Columns.Add(DataColumn)

        DataColumn = New DataColumn
        DataColumn.ColumnName = "Output"
        DataColumn.DataType = GetType(String)
        dt.Columns.Add(DataColumn)


        DataColumn = New DataColumn
        DataColumn.ColumnName = "Current"
        DataColumn.DataType = GetType(String)
        dt.Columns.Add(DataColumn)

        Return dt
    End Function

    Private Sub grd_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles grd.CellClick
        txt.Text = grd.Rows(e.RowIndex).Cells(0).Value
    End Sub

    Private Sub grd_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles grd.CellContentClick

    End Sub

    Private Sub txt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt.TextChanged
        lblExampleTime.Text = Now.ToString
        lblExample.Text = Now.ToString(txt.Text)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        txt_TextChanged(Nothing, Nothing)

        For i As Long = 0 To grd.Rows.Count - 1
            grd.Rows(i).Cells(2).Value = Now.ToString(grd.Rows(i).Cells(0).Value)
        Next

    End Sub
End Class
